<template>
  <svn-pro-card
    v-if="type !== 'add_block'"
    :link="false"
    class="w-full max-w-[640px] py-4 bg-surface"
    :class="size === ComponentSizes.compact ? '!border-0 !rounded-none px-5' : '!border !border-[#767680] border-opacity-100 !rounded-[8px] px-4'"
  >
    <div class="w-full flex flex-col !gap-4">
      <!-- Question type & controls -->
      <div
        class="flex gap-3"
        :class="type === 'template' ? 'flex-row-reverse items-center' : size === 'compact' ? 'flex-col' : 'flex-row-reverse items-center'"
      >
        <!-- Buttons -->
        <div
          class="flex flex-1 items-center"
          :class="type === 'template' ? 'justify-end' : size === 'compact' ? 'justify-between' : 'justify-end gap-1'"
        >
          <svn-pro-icon-button
            v-if="type !== 'template'"
            :variant="ButtonVariants.text"
            color="onSurfaceVariant"
            icon="custom:mingcute:arrow-up-line"
            @click="emit('move-question-up')"
          />
  
          <svn-pro-icon-button
            v-if="type !== 'template'"
            :variant="ButtonVariants.text"
            color="onSurfaceVariant"
            icon="custom:mingcute:arrow-down-line"
            @click="emit('move-question-down')"
          />
  
          <svn-pro-icon-button
            v-if="type !== 'template'"
            :variant="ButtonVariants.text"
            color="onSurfaceVariant"
            icon="custom:mingcute:copy-2-line"
            @click="emit('duplicate-question')"
          />
  
          <svn-pro-icon-button
            v-if="type !== 'template'"
            :variant="ButtonVariants.text"
            color="onSurfaceVariant"
            icon="custom:mingcute:delete-2-line"
            @click="emit('delete-question')"
          />

          <svn-pro-icon-button
            v-if="type === 'template'"
            :variant="ButtonVariants.text"
            color="onSurfaceVariant"
            icon="custom:mingcute:tag-line"
          />
        </div>
        
        <!-- Tag question type -->
        <svn-pro-info-tag
          v-if="type !== 'mcq_quiz'"
          leading-item="icon"
          :icon="getTagIcon()"
          :text="getTagText()"
          :tag-type="InfotagTypes.primary"
          :tag-style="InfotagStyles.filled"
          :tag-size="ComponentSizes.default"
        />
      </div>
  
      <!-- Question details (title, description, options) -->
      <div class="w-full flex flex-col items-start gap-4">
        <!-- Type template -->
        <svn-pro-select
          v-if="type === 'template'"
          v-model="templateType"
          label="Template type"
          :items="interviewTemplateTypes"
          :class="size === ComponentSizes.compact ? 'w-full' : 'w-1/2'"
          @update:model-value="updateTemplateType"
        />
  
        <!-- All types except paragraph -->
        <svn-pro-text-field
          v-if="(type !== InterviewAppQuestionTypes.paragraph)"
          v-model="title"
          class="w-full"
          :label="questionLabel"
          :variant="InputVariants.outlined"
          @update:model-value="updateTitle"
        />
  
        <!-- All types -->
        <svn-pro-text-area
          v-if="type !== 'mcq_quiz'"
          v-model="description"
          class="w-full"
          :rows="8"
          :max-rows="8"
          :label="descriptionLabel"
          :variant="InputVariants.outlined"
          @update:model-value="updateDescription"
        />

        <!-- Youtube Video (Only for template) -->
        <svn-pro-text-field
          v-if="type === 'template'"
          v-model="videoLink"
          class="w-full"
          label="Video link (Youtube)"
          :variant="InputVariants.outlined"
          @update:model-value="updateVideoLink"
        />
  
        <!-- {{ answerOptions }} -->
        <div
          v-if="(type !== 'template' && type !== InterviewAppQuestionTypes.chapter && type !== InterviewAppQuestionTypes.paragraph && type !== InterviewAppQuestionTypes.roadmap_update && type !== InterviewAppQuestionTypes.roadmap_create)"
          class="w-full flex flex-col items-start self-stretch gap-6"
        >
          <!-- Type rating -->
          <svn-pro-select
            v-if="type === InterviewAppQuestionTypes.rating"
            v-model="maxRating"
            :items="ratingItems"
            :label="ratingSelectLabel"
            :class="size === ComponentSizes.compact ? 'w-full' : 'w-1/2'"
            @update:model-value="updateMaxRating"
          />

          <!-- Type MCQ -->
          <div
            v-if="(type === InterviewAppQuestionTypes.mcq || type === 'mcq_quiz')"
            class="w-full flex flex-col gap-3"
          >
            <svn-pro-text subtitle-large medium>
              {{ 'Answer options' }} {{ type === 'mcq_quiz' ? ' (use checkbox for right answers)' : '' }}
            </svn-pro-text>

            <div
              v-if="answerOptions?.length"
              class="flex flex-col gap-4"
            >
              <div
                v-for="(option, index) in answerOptions"
                :key="option?.id"
                class="flex items-center gap-4"
              >
                <svn-pro-text-field
                  :model-value="option?.value"
                  class="w-full"
                  :label="`Option ${index + 1}`"
                  :variant="InputVariants.outlined"
                  @update:model-value="updateAnswerOption($event, index)"
                />

                <svn-pro-checkbox
                  :model-value="option?.correct"
                  color="primary"
                  @update:model-value="updateAnswerOptionCorrect($event, index)"
                />

                <svn-pro-icon-button
                  :variant="ButtonVariants.text"
                  :disabled="index === 0"
                  color="onSurfaceVariant"
                  :icon="index === 0 ? '' : 'custom:mingcute:delete-2-line'"
                  @click="index === 0 ? null : removeAnswerOption(index)"
                />
              </div>
            </div>

            <svn-pro-button
              :text="addAnswerOptionText"
              :variant="ButtonVariants.text"
              class="w-fit"
              prepend-icon="custom:mingcute:add-line"
              @click="addAnswerOption"
            />
          </div>
  
          <!-- Require/Visible for section -->
          <div
            v-if="type !== 'mcq_quiz'"
            :class="size === ComponentSizes.compact ? '' : 'self-end'"
          >
            <v-list
              select-strategy="classic"
              class="bg-transparent"
            >
              <v-list-item
                v-if="(type === InterviewAppQuestionTypes.mcq || type === InterviewAppQuestionTypes.rating)"
                lines="one"
                :active="false"
                trailing="switch"
                value="allow_comments"
                title="Allow comments"
                :class="size === ComponentSizes.compact ? 'w-full' : 'w-[360px]'"
                @click="toggleOption('allow_comments')"
              >
                <template #append>
                  <v-list-item-action>
                    <svn-pro-switch
                      v-model="selectedOptions"
                      value="allow_comments"
                      @click.stop
                    />
                  </v-list-item-action>
                </template>

                <template #title>
                  <svn-pro-text body-large regular color="onSurface">
                    {{ 'Allow comments' }}
                  </svn-pro-text>
                </template>
              </v-list-item>

              <v-list-item
                v-if="(type === InterviewAppQuestionTypes.mcq || type === InterviewAppQuestionTypes.rating || type === InterviewAppQuestionTypes.open) && isFeedbackOrSurvey"
                lines="one"
                :active="false"
                trailing="switch"
                value="required"
                title="Required"
                :class="size === ComponentSizes.compact ? 'w-full' : 'w-[360px]'"
                @click="toggleOption('required')"
              >
                <template #append>
                  <v-list-item-action>
                    <svn-pro-switch
                      v-model="selectedOptions"
                      value="required"
                      @click.stop
                    />
                  </v-list-item-action>
                </template>

                <template #title>
                  <svn-pro-text body-large regular color="onSurface">
                    {{ 'Required' }}
                  </svn-pro-text>
                </template>
              </v-list-item>

              <v-list-item
                v-else-if="!isFeedbackOrSurvey"
                v-for="item in visibleRequiredForList"
                :key="item?.value"
                :lines="item?.lines"
                :value="item?.value"
                :title="item?.title"
                :active="false"
                :class="size === ComponentSizes.compact ? 'w-full' : 'w-[360px]'"
                @click="toggleOption(item?.value)"
              >
                <template #append>
                  <v-list-item-action>
                    <svn-pro-switch
                      v-model="selectedOptions"
                      :value="item?.value"
                      @click.stop
                    />
                  </v-list-item-action>
                </template>

                <template #title>
                  <svn-pro-text body-large regular color="onSurface">
                    {{ item?.title }}
                  </svn-pro-text>
                </template>
              </v-list-item>
            </v-list>
          </div>
        </div>
      </div>
    </div>
  </svn-pro-card>

  <div
    v-else
    class="w-full flex items-center"
  >
    <svn-pro-divider color="[#767680]" class="w-full" />

    <svn-pro-menu :items="addMenuItems">
      <template #activator="{ props }">
        <svn-pro-button
          v-bind="props"
          variant="text"
          prepend-icon="custom:mingcute:add-line"
          :text="addButtonText"
        />
      </template>
    </svn-pro-menu>

    <svn-pro-divider color="[#767680]" class="w-full" />
  </div>
</template>

<script setup>
import { ref, onMounted } from "vue";
import SvnProText from "../styles/SvnProText.vue";
import SvnProMenu from "../../components/menu/SvnProMenu.vue";
import SvnProCard from "../../components/card/SvnProCard.vue";
import SvnProSelect from "../../components/input/SvnProSelect.vue";
import SvnProSwitch from "../../components/input/SvnProSwitch.vue";
import SvnProButton from "../../components/button/SvnProButton.vue";
import SvnProInfoTag from "../../components/chip/SvnProInfoTag.vue";
import SvnProCheckbox from "../../components/input/SvnProCheckbox.vue";
import SvnProDivider from "../../components/divider/SvnProDivider.vue";
import SvnProTextArea from "../../components/input/SvnProTextArea.vue";
import SvnProTextField from "../../components/input/SvnProTextField.vue";
import SvnProIconButton from "../../components/button/SvnProIconButton.vue";
import { InterviewAppQuestionTypes, ComponentSizes, InfotagStyles, InfotagTypes, InputVariants, ButtonVariants } from '../../constants/types'
import { watch } from "vue";

const props = defineProps({
  type: {
    type: String,
    default: InterviewAppQuestionTypes.open,
  },
  size: {
    type: String,
    default: ComponentSizes.compact,
  },
  allowComments: {
    type: Boolean,
    default: true,
  },
  addButtonText: {
    type: String,
    default: "Add",
  },
  titleValue: {
    type: String,
    default: "",
  },
  descriptionValue: {
    type: String,
    default: "",
  },
  videoLinkValue: {
    type: String,
    default: "",
  },
  templateTypeValue: {
    type: String,
    default: "",
  },
  maxRatingValue: {
    type: String,
    default: "5",
  },
  ratingSelectLabel: {
    type: String,
    default: "Max rating",
  },
  questionLabel: {
    type: String,
    default: "Question",
  },
  descriptionLabel: {
    type: String,
    default: "Description",
  },
  addAnswerOptionText: {
    type: String,
    default: "Add answer option",
  },
  addMenuItems: {
    type: Array,
    default: () => [],
  },
  optionsValue: {
    type: Array,
    default: () => [],
  },
  isFeedbackOrSurvey: {
    type: Boolean,
    default: false,
  },
  visibleForInterviewerLabel: {
    type: String,
    default: "Visible for interviewer",
  },
  RequiredForInterviewerLabel: {
    type: String,
    default: "Required for interviewer",
  },
  visibleForIntervieweeLabel: {
    type: String,
    default: "Visible for interviewee",
  },
  RequiredForIntervieweeLabel: {
    type: String,
    default: "Required for interviewee",
  },
});

const emit = defineEmits([
  'move-question-up',
  'move-question-down',
  'duplicate-question',
  'delete-question',
  'add-answer-option',
  'remove-answer-option',
  'update-answer-option',
  'update-answer-option-correct',
  'update-video-link',
  'update-title',
  'update-description',
  'update-template-type',
  'update-max-rating',
  'update-switches',
]);

onMounted(() => {
  title.value = props?.titleValue
  description.value = props?.descriptionValue
  videoLink.value = props?.videoLinkValue
  templateType.value = {
    value: props?.templateTypeValue,
    title: getTemplateTypeText(props?.templateTypeValue)
  }
  maxRating.value = {
    value: props?.maxRatingValue,
    title: props?.maxRatingValue
  }
  answerOptions.value = props?.optionsValue
});

const selectedOptions = ref([]);
const templateType = ref({
  value: "employee",
  title: "Interviewee (IE)",
})
const maxRating = ref({
  value: "5",
  title: "5",
})
const title = ref(null);
const videoLink = ref(null);
const description = ref(null);
const answerOptions = ref([]);
const ratingItems = ref([
  { value: "1", title: "1" },
  { value: "2", title: "2" },
  { value: "3", title: "3" },
  { value: "4", title: "4" },
  { value: "5", title: "5" },
  { value: "7", title: "7" },
  { value: "8", title: "8" },
  { value: "9", title: "9" },
  { value: "10", title: "10" },
])
const interviewTemplateTypes = ref([
  { value: "employee", title: "Interviewee (IE)" },
  { value: "manager", title: "Interviewer (IR)" },
  { value: "both", title: "Both" },
  { value: "cross", title: "Cross Review" },
]);
const visibleRequiredForList = ref([
  {
    lines: "one",
    trailing: "switch",
    value: "visible_for_interviewer",
    title: props?.visibleForInterviewerLabel,
  },
  {
    lines: "one",
    trailing: "switch",
    value: "required_for_interviewer",
    title: props?.RequiredForInterviewerLabel,
  },
  {
    lines: "one",
    trailing: "switch",
    value: "visible_for_interviewee",
    title: props?.visibleForIntervieweeLabel,
  },
  {
    lines: "one",
    trailing: "switch",
    value: "required_for_interviewee",
    title: props?.RequiredForIntervieweeLabel,
  },
])

const getTemplateTypeText = (value) => {
  switch (value) {
    case 'employee':
      return 'Interviewee (IE)'
    case 'manager':
      return 'Interviewer (IR)'
    case 'both':
      return 'Both'
    case 'cross':
      return 'Cross Review'
    default:
      return ''
  }
}

const toggleOption = (option) => {
  const found = selectedOptions?.value?.find(element => element === option)

  if (found) {
    selectedOptions.value = selectedOptions?.value?.filter(element => element !== option)
  } else {
    selectedOptions?.value?.push(option)
  }

  emit('update-switches', selectedOptions?.value)
}

const getTagIcon = () => {
  switch (props?.type) {
    case InterviewAppQuestionTypes.open:
      return 'mingcute:question-line'
    case InterviewAppQuestionTypes.rating:
      return 'mingcute:star-line'
    case InterviewAppQuestionTypes.mcq:
      return 'mingcute:checkbox-line'
    case InterviewAppQuestionTypes.chapter:
      return 'mingcute:list-check-3-line'
    case InterviewAppQuestionTypes.paragraph:
      return 'mingcute:text-2-line'
    case InterviewAppQuestionTypes.roadmap_create:
      return 'mingcute:target-line'
    case InterviewAppQuestionTypes.roadmap_update:
      return 'mingcute:target-line'
    case 'template':
      return 'mingcute:pencil-ruler-line'
    default:
      return 'mingcute:question-line'
  }
}

const getTagText = () => {
  switch (props?.type) {
    case InterviewAppQuestionTypes.open:
      return 'Open question'
    case InterviewAppQuestionTypes.rating:
      return 'Rating'
    case InterviewAppQuestionTypes.mcq:
      return 'Multi-choice'
    case InterviewAppQuestionTypes.chapter:
      return 'Chapter'
    case InterviewAppQuestionTypes.paragraph:
      return 'Paragraph'
    case InterviewAppQuestionTypes.roadmap_create:
      return 'Create target'
    case InterviewAppQuestionTypes.roadmap_update:
      return 'Update target'
    case 'template':
      return 'Template'
    default:
      return 'Open question'
  }
}

const updateTitle = () => {
  emit('update-title', title?.value)
}

const updateDescription = () => {
  emit('update-description', description?.value)
}

const updateVideoLink = () => {
  emit('update-video-link', videoLink?.value)
}

const updateTemplateType = () => {
  emit('update-template-type', templateType?.value)
}

const updateMaxRating = () => {
  emit('update-max-rating', maxRating?.value)
}

const addAnswerOption = () => {
  emit('add-answer-option')
  answerOptions?.value?.push({
    id: answerOptions?.value?.length + 1,
    value: "",
    correct: false,
  })
}

const removeAnswerOption = (index) => {
  emit('remove-answer-option', index)
  answerOptions?.value?.splice(index, 1)
}

const updateAnswerOption = (value, index) => {
  emit('update-answer-option', {
    index: index,
    value: value,
  })
  const found = answerOptions?.value?.[index]
  if (found) {
    found.value = value
  }
}

const updateAnswerOptionCorrect = (value, index) => {
  emit('update-answer-option-correct', {
    index: index,
    value: value,
  })
  const found = answerOptions?.value?.[index]
  if (found) {
    found.correct = value
  }
}

watch(props, (newValue, oldValue) => {
  if (newValue) {
    title.value = newValue?.titleValue
    description.value = newValue?.descriptionValue
    videoLink.value = newValue?.videoLinkValue
    templateType.value = {
      value: newValue?.templateTypeValue,
      title: getTemplateTypeText(newValue?.templateTypeValue)
    }
    maxRating.value = {
      value: newValue?.maxRatingValue,
      title: newValue?.maxRatingValue
    }
    answerOptions.value = newValue?.optionsValue
  }
})
</script>

<style scoped>
* :deep(.v-switch__track) {
  opacity: 1 !important;
}
</style>